diff --git a/common/ppc/pixel.c b/common/ppc/pixel.c
index 5553684..d9687b2 100644
--- a/common/ppc/pixel.c
+++ b/common/ppc/pixel.c
@@ -1665,38 +1665,43 @@ static int x264_pixel_var_16x16_altivec( uint8_t *pix, int i_stride )
 
 static int x264_pixel_var_8x8_altivec( uint8_t *pix, int i_stride )
 {
-    DECLARE_ALIGNED_16(uint32_t sum);
+    DECLARE_ALIGNED_16(uint32_t sum_tab[4]);
     DECLARE_ALIGNED_16(uint32_t sqr);
 
     LOAD_ZERO;
     vec_u32_t sqr_v = zero_u32v;
     vec_u32_t sum_v = zero_u32v;
 
-    vec_u8_t perm0 = vec_lvsl( 0, pix );
-    vec_u8_t perm1 = vec_lvsl( 0, pix+i_stride );
-
+    vec_u8_t perm_tab[] = {
+        CV(0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
+           0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17),
+        CV(0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
+           0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17),
+        CV(0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
+           0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x0E, 0x1F),
+        CV(0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
+           0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x0E, 0x1F)
+    };
+    vec_u8_t perm = perm_tab[!((unsigned long)pix & 0xF)<<1 & !(i_stride & 0x8)];
     int y;
     for( y = 0; y < 8; y+=2 )
     {
         vec_u8_t pix0_v = vec_ld(0, pix);
         vec_u8_t pix1_v = vec_ld(i_stride, pix);
-        pix0_v = vec_perm(pix0_v, pix0_v, perm0);
-        pix1_v = vec_perm(pix1_v, pix1_v, perm1);
-
-        vec_u8_t pix_v = vec_mergeh(pix0_v, pix1_v);
+        vec_u8_t pix_v = vec_perm(pix0_v, pix1_v, perm);
 
         sum_v = vec_sum4s(pix_v, sum_v);
         sqr_v = vec_msum(pix_v, pix_v, sqr_v);
 
         pix += i_stride<<1;
     }
-    sum_v = vec_add( sum_v, vec_sld( sum_v, sum_v, 8 ) );
+    sum_v = (vec_s32_t)vec_sums( (vec_s32_t)sum_v, zero_s32v );
     sqr_v = vec_add( sqr_v, vec_sld( sqr_v, sqr_v, 8 ) );
-    sum_v = vec_add( sum_v, vec_sld( sum_v, sum_v, 4 ) );
     sqr_v = vec_add( sqr_v, vec_sld( sqr_v, sqr_v, 4 ) );
-    vec_ste(sum_v, 0, &sum);
+    vec_ste(sum_v, 12, sum_tab);
     vec_ste(sqr_v, 0, &sqr);
 
+    uint32_t sum = sum_tab[3];
     uint32_t var = sqr - (sum * sum >> 6);
     return var;
 }